﻿//グループルビの場合は〓を∞に
app.changeGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences.findWhat = "〓([^《》][^《》]+?《[^《》　]+?》)";
app.changeGrepPreferences.changeTo = "∞$1";
app.documents[0].changeGrep(); //ドキュメント対象

//テキストフレーム内でモノルビ実行
for(x=0;x<app.documents[0].textFrames.length;x++){
	var myStory=app.documents[0].textFrames[x].parentStory;
	var srcText=myStory.contents;
	makeRuby();
//脚注内でモノルビ実行
	for(var fn=0;app.documents[0].textFrames[x].footnotes.length>fn;fn++){
		var  myStory = app.documents[0].textFrames[x].footnotes[fn];
		var srcText=myStory.contents;
		makeRuby();
	}
//表組み内でモノルビ実行
	for(var y=0;app.documents[0].textFrames[x].tables.length>y;y++){
		var myTable = app.documents[0].textFrames[x].tables.item(y);
		for(var z = 0;myTable.cells.length>z;z++){
			var myStory=myTable.cells[z];
			var srcText=myStory.contents;
			makeRuby();
		}
	}
}

//テキストフレーム内でグループルビ実行
for(x=0;x<app.documents[0].textFrames.length;x++){
	var myStory=app.documents[0].textFrames[x].parentStory;
	var srcText=myStory.contents;
	makeRubyG();
//脚注内でグループルビ実行
	for(var fn=0;app.documents[0].textFrames[x].footnotes.length>fn;fn++){
		var  myStory = app.documents[0].textFrames[x].footnotes[fn];
		var srcText=myStory.contents;
		makeRubyG();
	}
//表組み内でグループルビ実行
	for(var y=0;app.documents[0].textFrames[x].tables.length>y;y++){
		var myTable = app.documents[0].textFrames[x].tables.item(y);
		for(var z = 0;myTable.cells.length>z;z++){
			var myStory=myTable.cells[z];
			var srcText=myStory.contents;
			makeRubyG();
		}
	}
}

// モノルビチェック
function makeRuby(){
	var startOyaChar = "〓";	//親文字開始
	var startRubyChar = "《";	// ルビ開始
	var endRubyChar = "》";	// ルビ終了

//最初の〓を探す
	for (var b=srcText.length-1; b>=0; b--){
		if (srcText[b] != startOyaChar) continue;	// 〓が見つかるまで繰り返す
		var sp = b;	// 〓の位置はbということ。
//すぐ後の《を探す。	
		for (var c=b; c<srcText.length; c++){
			if (srcText[c] != startRubyChar) continue;	// 《が見つかるまで繰り返す
			var rubySp = c;	//《の位置はcということ。
//すぐ後の》を探す。	
			for (var d=c; d<srcText.length; d++){
					if (srcText[d] != endRubyChar) continue;	// 》が見つかるまで繰り返す
					var rubyEp = d;	//》の位置はdということ。
			break;}
		break;}
//ルビ文字を取得
	rubyObj = srcText.substring(rubySp+1,rubyEp);
//親文字を設定
	oyaObj = myStory.characters.itemByRange(sp+1,rubySp-1);
	oyaObj.rubyString = rubyObj;
	oyaObj.rubyFlag = true;
	oyaObj.rubyType = RubyTypes.perCharacterRuby;//モノルビを指定
//〓と《》を削除
	myStory.characters.itemByRange(rubySp,rubyEp).remove();
	myStory.characters.itemByRange(sp,sp).remove();
	}
}
// グループルビチェック
function makeRubyG(){
	var startOyaChar = "∞";	//親文字開始
	var startRubyChar = "《";	// ルビ開始
	var endRubyChar = "》";	// ルビ終了

//最初の〓を探す
	for (var b=srcText.length-1; b>=0; b--){
		if (srcText[b] != startOyaChar) continue;	// ∞が見つかるまで繰り返す
		var sp = b;	// ∞の位置はbということ。
//すぐ後の《を探す。	
		for (var c=b; c<srcText.length; c++){
			if (srcText[c] != startRubyChar) continue;	// 《が見つかるまで繰り返す
			var rubySp = c;	//《の位置はcということ。
//すぐ後の》を探す。	
			for (var d=c; d<srcText.length; d++){
					if (srcText[d] != endRubyChar) continue;	// 》が見つかるまで繰り返す
					var rubyEp = d;	//》の位置はdということ。
			break;}
		break;}
//ルビ文字を取得
	rubyObj = srcText.substring(rubySp+1,rubyEp);
//親文字を設定
	oyaObj = myStory.characters.itemByRange(sp+1,rubySp-1);
	oyaObj.rubyString = rubyObj;
	oyaObj.rubyFlag = true;
	oyaObj.rubyType = RubyTypes.groupRuby;//グループルビを指定
//∞と《》を削除
	myStory.characters.itemByRange(rubySp,rubyEp).remove();
	myStory.characters.itemByRange(sp,sp).remove();
	}
}

